"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var context_exports = {};
__export(context_exports, {
  Context: () => Context,
  builtinTransformers: () => builtinTransformers
});
module.exports = __toCommonJS(context_exports);
var import_formatter = require("../formatter");
var import_transformer = require("../transformer");
const outputFormattedError = (msg, type) => {
  if (type === "error") {
    console.error(msg);
  } else if (type === "warning") {
    console.warn(msg);
  }
};
const builtinTransformers = [
  import_transformer.cleanMessageTransformer,
  import_transformer.flattenCausesTransformer,
  import_transformer.moduleParseErrorTransformer
];
class Context {
  constructor(options = {}) {
    this.formatters = [];
    this.transformers = [];
    this.cwd = options.cwd || process.cwd();
    this.output = options.output || outputFormattedError;
    this.type = options.type || "error";
    var _options_withSources;
    this.withSources = (_options_withSources = options.withSources) !== null && _options_withSources !== void 0 ? _options_withSources : true;
    if (Array.isArray(options.formatters)) {
      this.formatters.push(...options.formatters);
    }
    if (options.formatters !== false) {
      this.formatters.push(import_formatter.prettyFormatter);
    }
    const transformers = [];
    if (options.transformers !== false) {
      transformers.push(...builtinTransformers);
    }
    if (Array.isArray(options.transformers)) {
      transformers.push(...options.transformers);
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Context,
  builtinTransformers
});
