"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var pretty_exports = {};
__export(pretty_exports, {
  prettyFormatter: () => prettyFormatter
});
module.exports = __toCommonJS(pretty_exports);
var import_webpack = require("webpack");
var import_chalk = __toESM(require("@modern-js/utils/chalk"));
const formatTraceEntry = (entry) => {
  const { callee, file, line, column } = entry;
  const prompt = import_chalk.default.gray("at");
  let location = "<anonymous>";
  file && (location = file);
  line && (location += `:${line}`);
  column && (location += `:${column}`);
  const sign = `${callee} (${location})`;
  return `    ${prompt} ${sign}`;
};
const SIGN_TEXT = {
  error: " ERROR ",
  warning: " WARN ",
  cause: " CAUSE "
};
const SIGN_COLOR = {
  error: import_chalk.default.bgRed.bold.black,
  warning: import_chalk.default.bgYellow.bold.black
};
const prettyFormatter = (e) => {
  const leadings = [];
  {
    const text = SIGN_TEXT[e.parent ? "cause" : e.type];
    const sign = SIGN_COLOR[e.type](text);
    leadings.push(sign, " ");
  }
  {
    const colorize = e.type === "error" ? import_chalk.default.red.bold : import_chalk.default.yellow.bold;
    const name = colorize(e.name);
    leadings.push(name, import_chalk.default.gray(": "), e.message);
  }
  const ret = [
    leadings.join("")
  ];
  if (e.raw instanceof import_webpack.WebpackError) {
    typeof e.raw.details === "string" && ret.push(e.raw.details);
  }
  ret.push(...e.trace.map(formatTraceEntry));
  e.cause && ret.push(prettyFormatter(e.cause));
  return ret.join("\n");
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  prettyFormatter
});
